﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess.Metadata;
using Telerik.OpenAccess.Metadata.Fluent;
using Telerik.OpenAccess;
using OpenAccessFluent;
using Telerik.OpenAccess.Metadata.Relational;

namespace OpenAccessFluent {
    public class FluentContext : OpenAccessContext 
    {
        static MyFluentMetadataSource metadata = new MyFluentMetadataSource();

        private const string SQLDbConnection = @"data source=localhost\sqlexpress;initial catalog=FluentTest;integrated security=True";
		private const string OracleDbConnection = "";

        public override void SaveChanges(ConcurrencyConflictsProcessingMode failureMode) 
        {

            base.SaveChanges(failureMode);
        }

        public FluentContext(Backend type) 
            :  base((type == Backend.Oracle ? OracleDbConnection : SQLDbConnection), 
                    new Telerik.OpenAccess.BackendConfiguration() 
                    {
                        Backend = (type == Backend.Oracle ? "oracle" : "mssql")
                    }, 
                    metadata) 
        {

        }

        public IQueryable<MyClass> IPTypes
        {
            get { return this.GetAll<MyClass>(); }
        }
    }
}
