﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess.Metadata.Fluent;
using OpenAccessFluent;
using Telerik.OpenAccess.Metadata;
using System.Reflection;
using System.Reflection.Emit;
using System.Linq.Expressions;
using System.Runtime.CompilerServices;
using System.Dynamic;
using System.Threading;

namespace OpenAccessFluent
{
    public class MyFluentMetadataSource : FluentMetadataSource
    {
        private static Backend BackendType = Backend.MsSql;

        protected override IList<MappingConfiguration> PrepareMapping()
        {
            IList<MappingConfiguration> preparedConfigurations = new List<MappingConfiguration>();

            MappingConfiguration<MyClass> classConfiguration = new MappingConfiguration<MyClass>();
            classConfiguration.MapType(x => new
            {
                ID = x.ID,
                Name = x.Name,
                FullName = x.FullName
            }).ToTable("TableName");

            classConfiguration.HasProperty(x => x.ID).IsIdentity();

            classConfiguration.HasProperty(x => x.ID, BackendType);
            classConfiguration.HasProperty(x => x.Name, BackendType);
            classConfiguration.HasProperty(x => x.FullName, BackendType);

            preparedConfigurations.Add(classConfiguration);
            return preparedConfigurations;
        }
    }
}

