﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess.Metadata;

namespace OpenAccessFluent
{
    class Program
    {
        static void Main(string[] args)
        {
            using (FluentContext context = new FluentContext(Backend.MsSql))
            {
                if (!context.GetSchemaHandler().DatabaseExists())
                {
                    context.GetSchemaHandler().CreateDatabase();
                    string ddl = context.GetSchemaHandler().CreateDDLScript();
                    if(!string.IsNullOrEmpty(ddl))
                    {
                        context.GetSchemaHandler().ExecuteDDLScript(ddl);
                    }
                }
                else
                {
                    string ddl = context.GetSchemaHandler().CreateUpdateDDLScript(new Telerik.OpenAccess.SchemaUpdateProperties());
                    context.GetSchemaHandler().ExecuteDDLScript(ddl);
                }

                MyClass foo = new MyClass();
                foo.ID = 1;
                foo.Name = "name";
                foo.FullName = "fullName";

                context.Add(foo);
                context.SaveChanges();
            }
        }
    }
}
